"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _forEach2 = require("lodash/forEach");

var _forEach3 = _interopRequireDefault(_forEach2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (options) {
	return function (WrappedComponent) {
		var _class, _temp2;

		var _require = require("react"),
		    PureComponent = _require.PureComponent,
		    PropTypes = _require.PropTypes;

		return _temp2 = _class = function (_PureComponent) {
			_inherits(_class, _PureComponent);

			function _class() {
				var _ref;

				var _temp, _this, _ret;

				_classCallCheck(this, _class);

				for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
					args[_key] = arguments[_key];
				}

				return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.un_subscribe = null, _this.state = { requests: {} }, _this.handleStoreUpdate = function () {
					var store = _this.context.store;
					var names = options.names;

					var _store$getState = store.getState(),
					    requests = _store$getState.requests;

					if (_this._old_state === requests) return;
					_this._old_state = requests;

					var current_requests = _this.state.requests;


					var _requests = {};
					var changed = false;

					(0, _forEach3.default)(requests, function (request) {
						var name = request.name,
						    timestamp = request.timestamp;


						if (names && names.indexOf(request.name) === -1) {
							return;
						}

						var currentlySelected = _requests[name];
						if (currentlySelected && currentlySelected.timestamp > timestamp) {
							return;
						}

						_requests[name] = request;
						if (_requests[name] !== current_requests[name]) {
							changed = true;
						}
					});

					if (changed) {
						_this.setState({
							requests: _requests
						});
					}
				}, _this.getQueryTools = function () {
					return {
						request: {
							complete: function complete(name) {
								var request = _this.state.requests[name];
								if (!request) return false;

								return request.status === _constants.COMPLETE_REQUEST || request.status === _constants.FAIL_REQUEST;
							},
							successful: function successful(name) {
								var request = _this.state.requests[name];
								if (!request) return false;

								return request.status === _constants.COMPLETE_REQUEST;
							},
							failed: function failed(name) {
								var request = _this.state.requests[name];
								if (!request) return false;

								return request.status === _constants.FAIL_REQUEST;
							},
							pending: function pending(name) {
								var request = _this.state.requests[name];
								if (!request) return false;

								return request.status === _constants.BEGIN_REQUEST;
							}
						}
					};
				}, _temp), _possibleConstructorReturn(_this, _ret);
			}

			_createClass(_class, [{
				key: "componentWillMount",
				value: function componentWillMount() {
					var store = this.context.store;

					if (!store) {
						return console.warn("withRequest requires a redux store to be in context");
					}

					this.un_subscribe = store.subscribe(this.handleStoreUpdate);
				}
			}, {
				key: "componentWillUnmount",
				value: function componentWillUnmount() {
					this.un_subscribe();
				}
			}, {
				key: "render",
				value: function render() {
					return React.createElement(WrappedComponent, _extends({}, this.props, {
						requests: this.state.requests
					}, this.getQueryTools()));
				}
			}]);

			return _class;
		}(PureComponent), _class.contextTypes = {
			store: PropTypes.object
		}, _temp2;
	};
};